import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.UI.Extensions";
import "KragenPlugs.KragenSlots";
import "KragenPlugs.DUInterface";

SetupWindow = class( KragenPlugs.DUInterface.Window );

function SetupWindow:Constructor(name)

	KragenPlugs.DUInterface.Window.Constructor( self, 356, 460 );
	
	self.remove = false;
	
	self:SetVisible(false);
	self:SetPosition(100, 100);
	
 	self.tbHolder:SetWidth(240);
 	self.tbRight:SetPosition(self.tbHolder:GetWidth()-35,0)
	self.tbCenter:SetSize(self.tbHolder:GetWidth()-70,42);
	self.tbCenter:SetPosition(self.tbLeft:GetLeft()+35,0)
	self.bg:SetSize(310,420);
	self.bg:SetBackColor(Turbine.UI.Color(.9,0,0,0));
	self.text:SetText("KS: "..name);
	self.text:SetWidth(self.tbHolder:GetWidth());
	self.text:SetHeight(20);
	self.text:SetTextAlignment(Turbine.UI.ContentAlignment.Left);
	self.clButton:SetVisible( false );
	self.tw=Turbine.UI.Window();
	self.tw:SetVisible(true);
	self.tw:SetParent(self);
	self.tw:SetSize(356,460);
	self.tw:SetPosition(0,0);
	self.tw:SetMouseVisible(false);
	
	self.qsTitle=Turbine.UI.Label();
	self.qsTitle:SetParent(self.tw);
	self.qsTitle:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.qsTitle:SetFontStyle(Turbine.UI.FontStyle.None );
	self.qsTitle:SetForeColor(Turbine.UI.Color(1,0.96,0.874,0.576));
	self.qsTitle:SetText("Quickslots");
	self.qsTitle:SetSize(356,20)
	self.qsTitle:SetPosition(0, 50);
	self.qsTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	self.qs = { };
	
	self.qs[1]=Turbine.UI.Lotro.Quickslot();
	self.qs[1]:SetParent(self.tw);
	self.qs[1]:SetSize(36,36);
	self.qs[1]:SetPosition(20,70);

	self.qs[2]=Turbine.UI.Lotro.Quickslot();
	self.qs[2]:SetParent(self.tw);
	self.qs[2]:SetSize(36,36);
	self.qs[2]:SetPosition(60,70);

	self.qs[3]=Turbine.UI.Lotro.Quickslot();
	self.qs[3]:SetParent(self.tw);
	self.qs[3]:SetSize(36,36);
	self.qs[3]:SetPosition(100,70);
	
	self.qs[4]=Turbine.UI.Lotro.Quickslot();
	self.qs[4]:SetParent(self.tw);
	self.qs[4]:SetSize(36,36);
	self.qs[4]:SetPosition(140,70);
	
	self.qs[5]=Turbine.UI.Lotro.Quickslot();
	self.qs[5]:SetParent(self.tw);
	self.qs[5]:SetSize(36,36);
	self.qs[5]:SetPosition(180,70);
	
	self.qs[6]=Turbine.UI.Lotro.Quickslot();
	self.qs[6]:SetParent(self.tw);
	self.qs[6]:SetSize(36,36);
	self.qs[6]:SetPosition(220,70);
	
	self.qs[7]=Turbine.UI.Lotro.Quickslot();
	self.qs[7]:SetParent(self.tw);
	self.qs[7]:SetSize(36,36);
	self.qs[7]:SetPosition(260,70);
	
	self.qs[8]=Turbine.UI.Lotro.Quickslot();
	self.qs[8]:SetParent(self.tw);
	self.qs[8]:SetSize(36,36);
	self.qs[8]:SetPosition(300,70);
	
	self.clearqs = Turbine.UI.Lotro.Button();
	self.clearqs:SetParent(self.tw);
	self.clearqs:SetSize(200,18);
	self.clearqs:SetPosition(356/2 - 100,115);
	self.clearqs:SetText("Clear Quickslots");
	
	self.onclick=KragenPlugs.DUInterface.CheckBox();
	self.onclick:SetParent(self.tw);
	self.onclick:SetVisible(true);
	self.onclick:SetChecked(true);
	self.onclick:SetDisabled(false);
	self.onclick:SetText("Change On Click");
	self.onclick:SetPosition(45,160);
	
	self.onscroll=KragenPlugs.DUInterface.CheckBox();
	self.onscroll:SetParent(self.tw);
	self.onscroll:SetVisible(true);
	self.onscroll:SetChecked(false);
	self.onscroll:SetDisabled(false);
	self.onscroll:SetText("Change On Scroll");
	self.onscroll:SetPosition(45,190);
	
	self.incombat=KragenPlugs.DUInterface.CheckBox();
	self.incombat:SetParent(self.tw);
	self.incombat:SetVisible(true);
	self.incombat:SetChecked(true);
	self.incombat:SetDisabled(false);
	self.incombat:SetText("In Combat");
	self.incombat:SetPosition(45,220);
	
	self.outcombat=KragenPlugs.DUInterface.CheckBox();
	self.outcombat:SetParent(self.tw);
	self.outcombat:SetVisible(true);
	self.outcombat:SetChecked(true);
	self.outcombat:SetDisabled(false);
	self.outcombat:SetText("Out of Combat");
	self.outcombat:SetPosition(45,250);
	
    self.hover=KragenPlugs.DUInterface.CheckBox();
	self.hover:SetParent(self.tw);
	self.hover:SetVisible(true);
	self.hover:SetChecked(true);
	self.hover:SetDisabled(false);
	self.hover:SetText("Hover Effect");
	self.hover:SetPosition(45,280);
	
	self.slider1 = KragenPlugs.DUInterface.Slider();
	self.slider1:SetParent(self.tw);
	self.slider1:SetPosition(60,310);
	self.slider1:SetSize(250,340);
	self.slider1:SetText("Min Opacity");
	self.slider1:SetMinMax(0,1);
	self.slider1:SetStep(.02);
	self.slider1:SetPlaces(2);
	self.slider1:SetValue(.4);
	
	self.slider2 = KragenPlugs.DUInterface.Slider();
	self.slider2:SetParent(self.tw);
	self.slider2:SetPosition(60,360);
	self.slider2:SetSize(250,340);
	self.slider2:SetText("Max Opacity");
	self.slider2:SetMinMax(0,1);
	self.slider2:SetStep(.02);
	self.slider2:SetPlaces(2);
	self.slider2:SetValue(1);
	
    self.delete = Turbine.UI.Lotro.Button();
	self.delete:SetParent(self.tw);
	self.delete:SetSize(90,18);
	self.delete:SetPosition(35,420);
	self.delete:SetText("Remove");

	self.accept = Turbine.UI.Lotro.Button();
	self.accept:SetParent(self.tw);
	self.accept:SetSize(90,18);
	self.accept:SetPosition(235,420);
	self.accept:SetText("Accept");

	self.cancel = Turbine.UI.Lotro.Button();
	self.cancel:SetParent(self.tw);
	self.cancel:SetSize(90,18);
	self.cancel:SetPosition(135,420);
	self.cancel:SetText("Cancel");
	
	self.clearqs.MouseClick = function(sender,args)
		self.qs[1]:SetShortcut(nil);
		self.qs[2]:SetShortcut(nil);
		self.qs[3]:SetShortcut(nil);
		self.qs[4]:SetShortcut(nil);
		self.qs[5]:SetShortcut(nil);
		self.qs[6]:SetShortcut(nil);
		self.qs[7]:SetShortcut(nil);
		self.qs[8]:SetShortcut(nil);
		self:SetVisible( false );
		self:SetVisible( true );
	end
	
    self.cancel.MouseClick = function(sender,args)
        self.onclick:SetChecked(self.settings.onclick);
        self.onscroll:SetChecked(self.settings.onscroll);
        self.incombat:SetChecked(self.settings.incombat);
        self.outcombat:SetChecked(self.settings.outcombat);
        self.hover:SetChecked(self.settings.hover);
        self.slider1:SetValue(self.settings.minopacity);
        self.slider2:SetValue(self.settings.maxopacity);
        if (type(self.settings.shortcut) == "table") then
			for i = 1, 8 do
				self.qs[i]:SetShortcut(Turbine.UI.Lotro.Shortcut(self.settings.shortcut[i].Type, self.settings.shortcut[i].Data));
			end
		end
		self:Close();
	end
	
	self.delete.MouseClick = function(sender,args)
		self.remove = true;
		self:Close();
	end

	self.accept.MouseClick = function(sender,args)
		self:Close();
	end

	self.Closing = function(sender,args)
		
	end

end

function SetupWindow:ShowSetup(settings)
	self:SetVisible( true );
	self.settings = settings;
	
	if (type(settings.shortcut) == "table") then
		for i = 1, 8 do
			self.qs[i]:SetShortcut(Turbine.UI.Lotro.Shortcut(settings.shortcut[i].Type, settings.shortcut[i].Data));
		end
	end
	
	self.onclick:SetChecked(settings.onclick);
	self.onscroll:SetChecked(settings.onscroll);
	self.incombat:SetChecked(settings.incombat);
	self.outcombat:SetChecked(settings.outcombat);
	self.hover:SetChecked(settings.hover);
  	self.slider1:SetValue(settings.minopacity);
  	self.slider2:SetValue(settings.maxopacity);
end

function SetupWindow:GetShortcuts()
	local shortcut = { };
	
	for i = 1, 8 do
	    shortcut[i] = { };
		shortcut[i].Type = self.qs[i]:GetShortcut():GetType();
		shortcut[i].Data = self.qs[i]:GetShortcut():GetData();
	end
	
	return shortcut;
end